// ignore_for_file: unnecessary_brace_in_string_interps

import 'package:galaxeus_lib/scheme/reg_exp_data_scheme.dart';

extension GalaxeusRegExpExtension on RegExp {
  bool hashData(dynamic input) {
    try {
      if (input is String == false) {
        input = input.toString();
      }
      return hasMatch(input);
    } catch (e) {
      return false;
    }
  }

  RegExp fromJson(Map data) {
    RegExpDataScheme regExpDataScheme = RegExpDataScheme(data);
    return RegExp(
      regExpDataScheme.pattern ?? "",
      multiLine: regExpDataScheme.is_multi_line ?? false,
      caseSensitive: regExpDataScheme.is_case_sensitive ?? false,
      unicode: regExpDataScheme.is_unicode ?? false,
      dotAll: regExpDataScheme.is_dot_all ?? false,
    );
  }

  Map toJson() {
    return {
      "@type": "regExpDataScheme",
      "pattern": pattern,
      "is_multi_line": isMultiLine,
      "is_case_sensitive": isCaseSensitive,
      "is_unicode": isUnicode,
      "is_dot_all": isUnicode,
    };
  }
}

extension GalaxeusListRegExpExtension on List<RegExp> {
  bool hashData(dynamic input) {
    int count = 0;
    for (var i = 0; i < length; i++) {
      RegExp regExp = this[i];
      if (regExp.hashData(input)) {
        count++;
      }
    }
    return (count == length);
  }
}

extension GalaxeusListListRegExpExtension on List<List<RegExp>> {
  bool hashData(dynamic input) {
    for (var i = 0; i < length; i++) {
      if (this[i].hashData(input)) {
        return true;
      }
    }
    return false;
  }
}
