// ignore_for_file: unnecessary_brace_in_string_interps, non_constant_identifier_names, unnecessary_string_interpolations

import 'package:galaxeus_lib/extension/regexp.dart';

extension GalaxeusExtensionString on String {
  bool isFullData(RegExp regExp) {
    int count = 0;
    for (var i = 0; i < length; i++) {
      if (regExp.hashData(this[i])) {
        count += 1;
      }
    }
    return (count == length);
  }

  RegExp toRegExp({
    bool multiLine = false,
    bool caseSensitive = false,
    bool unicode = false,
    bool dotAll = false,
  }) {
    String message = "";
    for (var i = 0; i < length; i++) {
      String msg = this[i];
      String symbol = r"*#";
      String similar_word = "";

      if (RegExp(r"^(a)$", caseSensitive: false).hashData(msg)) {
        similar_word = "4";
      }
      if (RegExp(r"^(i)$", caseSensitive: false).hashData(msg)) {
        similar_word = "1";
      }
      if (RegExp(r"^(e)$", caseSensitive: false).hashData(msg)) {
        similar_word = "3";
      }
      if (RegExp(r"^(o)$", caseSensitive: false).hashData(msg)) {
        similar_word = "0";
      }
      if (RegExp(r"^(g)$", caseSensitive: false).hashData(msg)) {
        similar_word = "9";
      }
      if (RegExp(r"^(s)$", caseSensitive: false).hashData(msg)) {
        similar_word = "5";
      }

      if (!RegExp(r"^(a|i|u|e|o)$", caseSensitive: false).hashData(msg)) {
        if (length < 5) {
          symbol = "";
        }
      }

      String msg_data = "[${msg}${similar_word}${symbol}]";
      msg = "(${msg_data}+|${msg_data})";
      if (i == (length - 1)) {
        message += "${msg}";
      } else {
        message += "${msg}([ \\n]+)?";
      }
    }
    return RegExp(
      message,
      multiLine: multiLine,
      caseSensitive: caseSensitive,
      unicode: unicode,
      dotAll: dotAll,
    );
  }

  String hideData({int start = 2, int end = 2}) {
    var message = "";
    var numStart = start;
    var numEnd = length - end;
    for (int i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == numEnd) {
        numEnd--;
        message += loopData;
      } else if (i == numStart) {
        numStart++;
        message += "*";
      } else {
        message += loopData;
      }
    }
    return message;
  }

  String camelCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toUpperCase();
      } else {
        if (regExp.hasMatch(text[text.length - 1])) {
          text += loopData.toUpperCase();
        } else {
          text += loopData;
        }
      }
    }
    return text.replaceAll(regExp, "");
  }

  String toLowerCaseFirstData() {
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (i == 0) {
        text += loopData.toLowerCase();
      } else {
        text += loopData;
      }
    }
    return text;
  }

  String snakeCaseClass({RegExp? regExp}) {
    regExp ??= RegExp(r"(_)", caseSensitive: false);
    String text = "";
    for (var i = 0; i < length; i++) {
      var loopData = this[i];
      if (RegExp(r"[A-Z]").hashData(loopData) && i != 0) {
        text += "_${loopData}";
      } else {
        text += loopData;
      }
    }
    return text.toLowerCase();
  }
}
